From 55dc363dd6219d1d7ce4f13178cd1b843649e7a8 Mon Sep 17 00:00:00 2001
From: Liyang HU <git@liyang.hu>
Date: Sun, 25 Sep 2011 14:38:10 +0900
Subject: [PATCH] Rewrite RULES for realToFrac between {Nominal,}DiffTime and Pico

---
 Data/Time/Clock/Scale.hs |    8 +++++++-
 Data/Time/Clock/UTC.hs   |    9 +++++++++
 2 files changed, 16 insertions(+), 1 deletions(-)

diff --git a/Data/Time/Clock/Scale.hs b/Data/Time/Clock/Scale.hs
index 37c3f32..30e2e9a 100644
--- a/Data/Time/Clock/Scale.hs
+++ b/Data/Time/Clock/Scale.hs
@@ -8,7 +8,7 @@ module Data.Time.Clock.Scale
 	UniversalTime(..),
 
 	-- * Absolute intervals
-	DiffTime,
+	DiffTime (..),
         secondsToDiffTime, picosecondsToDiffTime
 ) where
 
@@ -106,3 +106,9 @@ secondsToDiffTime = fromInteger
 -- | Create a 'DiffTime' from a number of picoseconds.
 picosecondsToDiffTime :: Integer -> DiffTime
 picosecondsToDiffTime x = fromRational (x % 1000000000000)
+
+{-# RULES
+"realToFrac/DiffTime→Pico"              realToFrac = \ (MkDiffTime ps) -> ps
+"realToFrac/Pico→DiffTime"              realToFrac = MkDiffTime
+  #-}
+
diff --git a/Data/Time/Clock/UTC.hs b/Data/Time/Clock/UTC.hs
index e172b15..6b093df 100644
--- a/Data/Time/Clock/UTC.hs
+++ b/Data/Time/Clock/UTC.hs
@@ -118,3 +118,12 @@ instance RealFrac NominalDiffTime where
 	round (MkNominalDiffTime a) = round a
 	ceiling (MkNominalDiffTime a) = ceiling a
 	floor (MkNominalDiffTime a) = floor a
+
+{-# RULES
+"realToFrac/DiffTime→NominalDiffTime"   realToFrac = \ (MkDiffTime ps) -> MkNominalDiffTime ps
+"realToFrac/NominalDiffTime→DiffTime"   realToFrac = \ (MkNominalDiffTime ps) -> MkDiffTime ps
+
+"realToFrac/NominalDiffTime→Pico"       realToFrac = \ (MkNominalDiffTime ps) -> ps
+"realToFrac/Pico→NominalDiffTime"       realToFrac = MkNominalDiffTime
+  #-}
+
-- 
1.7.4

